#![no_std]
#![no_main]
#![feature(alloc_error_handler)]
extern crate alloc;

use crate::utils::clear_bss;
use core::arch::global_asm;

mod boards;
mod config;
mod console;
mod sbi;
mod sync;
mod syscall;
mod task;
mod timer;
mod trap;
mod utils;
mod memory;

global_asm!(include_str!("entry.asm"));
global_asm!(include_str!("link_app.asm"));

#[no_mangle]
fn rust_main() -> ! {
    clear_bss();
    log_information!("Hello, rCore!");
    trap::init();

    unreachable!()
}
